package com.brooklyn.api.model;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * Entity class representing a User in the system. This class maps to the USERS table in the
 * database.
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name = "USERS")
public class User {

  /**
   * The unique identifier for the User. It is automatically generated by the database using its
   * identity column feature.
   */
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  @Column(name = "ID", updatable = false, nullable = false)
  private Long id;

  /** The email address of the User. It must be unique and cannot be null. */
  @Column(name = "EMAIL", unique = true, nullable = false)
  private String email;

  /** The encrypted password of the User. It cannot be null. */
  @Column(name = "PASSWORD", nullable = false)
  private String password;

  /** The first name of the User. It is optional. */
  @Column(name = "FIRST_NAME")
  private String firstName;

  /** The last name of the User. It is optional. */
  @Column(name = "LAST_NAME")
  private String lastName;

  /**
   * The role assigned to the User. It indicates the user's role within the system and cannot be
   * null.
   */
  @Column(name = "ROLE", nullable = false)
  private String role;

  /**
   * Constructs a new User with the specified email and password.
   *
   * @param email the email address of the User
   * @param password the encrypted password of the User
   */
  public User(String email, String password) {
    this.email = email;
    this.password = password;
  }

  /**
   * Constructs a new User with the specified email, password, first name, and last name.
   *
   * @param email the email address of the User
   * @param password the encrypted password of the User
   * @param firstName the first name of the User
   * @param lastName the last name of the User
   */
  public User(String email, String password, String firstName, String lastName) {
    this.email = email;
    this.password = password;
    this.firstName = firstName;
    this.lastName = lastName;
  }
}
